searchNodes=[{"doc":"ExDuck is an Elixir Client for the DuckDuckGo Instant Answer API","ref":"ExDuck.html","title":"ExDuck","type":"module"},{"doc":"Query the DuckDuckGo Instant Answer API into a normalized answer Will return a map of normalized results from the API Will raise in case of errors This is exactly the same as calling ExDuck . query! ( &quot;elixir language&quot; ) |&gt; ExDuck . understand ( ) Examples iex&gt; ExDuck . answer! ( &quot;Elixir Language&quot; ) . heading &quot;Elixir (programming language)&quot;","ref":"ExDuck.html#answer!/1","title":"ExDuck.answer!/1","type":"function"},{"doc":"Query the DuckDuckGo Instant Answer API Will return the raw (JSON-decoded) results from the API Will raise in case of errors Examples iex&gt; ExDuck . query! ( &quot;Elixir Language&quot; ) |&gt; Map . get ( &quot;Heading&quot; ) &quot;Elixir (programming language)&quot;","ref":"ExDuck.html#query!/1","title":"ExDuck.query!/1","type":"function"},{"doc":"Translate a normalized answer or raw query results to markdown Examples iex&gt; ExDuck . query! ( &quot;Elixir Language&quot; ) ...&gt; |&gt; ExDuck . to_markdown ( ) ...&gt; |&gt; String . starts_with? ( &quot;# Elixir (programming language)&quot; )","ref":"ExDuck.html#to_markdown/1","title":"ExDuck.to_markdown/1","type":"function"},{"doc":"Normalize a response from the DuckDuckGo Instant Answer API This is the real deal of this library. Querying the API is simply HTTP GET and JSON parsing. This function is where DuckDuckGo's several types of answers are parsed into consistent forms and non-responses are recognized (e.g. calculation answers). I'm not sold on my current state of normalization. But it does suffice. Calling understand/1 with an already normalized answer is idempotent. Examples # a direct answer iex&gt; elixir = ExDuck . query! ( &quot;Elixir Language&quot; ) |&gt; ExDuck . understand ( ) iex&gt; elixir |&gt; Map . keys ( ) [ :answer , :entity , :heading , :image , :image_caption , :information , :related , :source , :type , :url ] # a category answer iex&gt; simpsons_characters = ExDuck . query! ( &quot;Simpsons Characters&quot; ) |&gt; ExDuck . understand ( ) iex&gt; simpsons_characters |&gt; Map . keys ( ) [ :entries , :heading , :type ] iex&gt; simpsons_characters . type == &quot;category&quot; true # understanding is idempotent iex&gt; elixir = ExDuck . query! ( &quot;Elixir Language&quot; ) |&gt; ExDuck . understand ( ) iex&gt; elixir == ExDuck . understand ( elixir )","ref":"ExDuck.html#understand/1","title":"ExDuck.understand/1","type":"function"},{"doc":"ExDuck is an Elixir library to query the DuckDuckGo Instant Answer API . It can convert answer results to markdown.","ref":"readme.html","title":"ExDuck","type":"extras"},{"doc":"ExDuck can be installed by adding ex_duck to your list of dependencies in mix.exs : def deps do [ { :ex_duck , &quot;~&gt; 0.1.2&quot; } ] end","ref":"readme.html#installation","title":"ExDuck - Installation","type":"extras"},{"doc":"Full API documentation is published on hexdocs .","ref":"readme.html#api-documentation","title":"ExDuck - API Documentation","type":"extras"},{"doc":"If you want the data for the answer then ExDuck.answer!/1 is what you want. It queries the DuckDuckGo instant answer API and then parses the result into a map of relevant extracted data. ExDuck.query!/1 will return the raw results from the DuckDuckGo Instant Answer API. ExDuck.to_markdown/1 will convert a given answer or query result into markdown. iex&gt; ExDuck . answer! ( &quot;Elixir Language&quot; ) %{ answer : &quot;Elixir is a functional, concurrent, general-purpose programming language that runs on the BEAM virtual machine which is also used to implement the Erlang programming language. Elixir builds on top of Erlang and shares the same abstractions for building distributed, fault-tolerant applications. Elixir also provides productive tooling and an extensible design. The latter is supported by compile-time metaprogramming with macros and polymorphism via protocols. Elixir is used by companies such as PagerDuty, Discord, Brex, E-MetroTel, Pinterest, Moz, Bleacher Report, The Outline, Inverse, Divvy, FarmBot and for building embedded systems. The community organizes yearly events in the United States, Europe and Japan as well as minor local events and conferences.&quot; , entity : &quot;programming language&quot; , heading : &quot;Elixir (programming language)&quot; , image : &quot;https://duckduckgo.com/i/6bb6708a.png&quot; , image_caption : &quot;Elixir (programming language)&quot; , information : [ %{ label : &quot;Paradigm&quot; , value : &quot;multi-paradigm: functional, concurrent, distributed, process-oriented&quot; } , %{ label : &quot;First appeared&quot; , value : &quot;2012&quot; } , %{ label : &quot;Typing discipline&quot; , value : &quot;dynamic, strong, duck&quot; } , %{ label : &quot;Platform&quot; , value : &quot;Erlang&quot; } , %{ label : &quot;License&quot; , value : &quot;Apache License 2.0&quot; } , %{ label : &quot;Filename extensions&quot; , value : &quot;ex.exs&quot; } ] , related : [ %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/Concurrent_computing \\&quot; &gt;Concurrent computing&lt;/a&gt;&lt;br /&gt; - Concurrent computing is a form of computing in which several computations are executed concurrently—during overlapping time periods—instead of sequentially—with one completing before the next starts.&quot; , url : &quot;https://duckduckgo.com/Concurrent_computing&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/Distributed_computing \\&quot; &gt;Distributed computing&lt;/a&gt;&lt;br /&gt; - Distributed computing is a field of computer science that studies distributed systems. A distributed system is a system whose components are located on different networked computers, which communicate and coordinate their actions by passing messages to one another from any system.&quot; , url : &quot;https://duckduckgo.com/Distributed_computing&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/c/Pattern_matching_programming_languages \\&quot; &gt;Pattern matching programming languages&lt;/a&gt;&lt;br /&gt;&quot; , url : &quot;https://duckduckgo.com/c/Pattern_matching_programming_languages&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/c/Concurrent_programming_languages \\&quot; &gt;Concurrent programming languages&lt;/a&gt;&lt;br /&gt;&quot; , url : &quot;https://duckduckgo.com/c/Concurrent_programming_languages&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/c/Functional_languages \\&quot; &gt;Functional languages&lt;/a&gt;&lt;br /&gt;&quot; , url : &quot;https://duckduckgo.com/c/Functional_languages&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/c/Programming_languages \\&quot; &gt;Programming languages&lt;/a&gt;&lt;br /&gt;&quot; , url : &quot;https://duckduckgo.com/c/Programming_languages&quot; } , %{ category : &quot;General&quot; , image : nil , text : &quot;&lt;a href= \\&quot; https://duckduckgo.com/c/Software_using_the_Apache_license \\&quot; &gt;Software using the Apache license&lt;/a&gt;&lt;br /&gt;&quot; , url : &quot;https://duckduckgo.com/c/Software_using_the_Apache_license&quot; } ] , source : &quot;Wikipedia&quot; , type : &quot;answer&quot; , url : &quot;https://en.wikipedia.org/wiki/Elixir_(programming_language)&quot; }","ref":"readme.html#usage","title":"ExDuck - Usage","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Stephen Ball Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]